#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  clrRoyalBlue
#property indicator_color2  clrRed
#property indicator_color3  clrSilver
#property indicator_color4  clrDimGray
#property indicator_color5  clrRoyalBlue
#property indicator_color6  clrRed
#property indicator_color7  clrSilver
#property indicator_color8  clrDimGray
#property strict

//
//
//
//
//

input bool            alertsOn         = true;              // Alerts on true/false?
input bool            alertsOnCurrent  = false;             // Alerts on still open bar true/false?
input bool            alertsMessage    = true;              // Alerts message true/false?
input bool            alertsSound      = false;             // Alerts sound true/false?
input bool            alertsEmail      = false;             // Alerts email true/false?
input bool            alertsPushNotif  = false;             // Alerts notification true/false?
input int             WickWidth        = 1;                 // Candle wick width
input int             BodyWidth        = 2;                 // If auto width = false then use this
input bool            UseAutoWidth     = true;              // Auto adjust candle body width

double Buffer1[],Buffer2[],Buffer3[],Buffer4[],Buffer5[],Buffer6[],Buffer7[],Buffer8[],trend[];
int candlewidth=0;


//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int OnInit()
{
   if (UseAutoWidth)
   {
      int scale = int(ChartGetInteger(0,CHART_SCALE));
      switch(scale) 
	   {
	      case 0: candlewidth =  1; break;
	      case 1: candlewidth =  1; break;
		   case 2: candlewidth =  2; break;
		   case 3: candlewidth =  3; break;
		   case 4: candlewidth =  6; break;
		   case 5: candlewidth = 14; break;
	   }
	}
   else { candlewidth = BodyWidth; }
   IndicatorBuffers(9);
   SetIndexBuffer(0, Buffer1,INDICATOR_DATA); SetIndexStyle(0,DRAW_HISTOGRAM,0,candlewidth); SetIndexEmptyValue(0,0);
   SetIndexBuffer(1, Buffer2,INDICATOR_DATA); SetIndexStyle(1,DRAW_HISTOGRAM,0,candlewidth); SetIndexEmptyValue(1,0);
   SetIndexBuffer(2, Buffer3,INDICATOR_DATA); SetIndexStyle(2,DRAW_HISTOGRAM,0,candlewidth); SetIndexEmptyValue(2,0);
   SetIndexBuffer(3, Buffer4,INDICATOR_DATA); SetIndexStyle(3,DRAW_HISTOGRAM,0,candlewidth); SetIndexEmptyValue(3,0);
   SetIndexBuffer(4, Buffer5,INDICATOR_DATA); SetIndexStyle(4,DRAW_HISTOGRAM,0,WickWidth);   SetIndexEmptyValue(4,0);
   SetIndexBuffer(5, Buffer6,INDICATOR_DATA); SetIndexStyle(5,DRAW_HISTOGRAM,0,WickWidth);   SetIndexEmptyValue(5,0);
   SetIndexBuffer(6, Buffer7,INDICATOR_DATA); SetIndexStyle(6,DRAW_HISTOGRAM,0,WickWidth);   SetIndexEmptyValue(6,0);
   SetIndexBuffer(7, Buffer8,INDICATOR_DATA); SetIndexStyle(7,DRAW_HISTOGRAM,0,WickWidth);   SetIndexEmptyValue(7,0);
   SetIndexBuffer(8, trend,  INDICATOR_CALCULATIONS);
return(INIT_SUCCEEDED);
}

int OnCalculate (const int       rates_total,
                 const int       prev_calculated,
                 const datetime& time[],
                 const double&   open[],
                 const double&   high[],
                 const double&   low[],
                 const double&   close[],
                 const long&     tick_volume[],
                 const long&     volume[],
                 const int&      spread[] )
{
   if(ChartGetInteger(0,CHART_SCALE) != candlewidth) OnInit();
   int i,counted_bars = prev_calculated;
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(rates_total-counted_bars,rates_total-1);
              
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) 
   {
      double haOpen  = (i<rates_total-1) ? (open[i+1]+close[i+1])*0.5 : (open[i]+close[i])*0.5;
      double haClose = (open[i]+high[i]+low[i]+close[i])*0.25;
      double haHigh  = fmax(high[i],fmax(haOpen,haClose));
      double haLow   = fmin(low[i], fmin(haOpen,haClose));
      
      if(i==rates_total-1) continue;
      double acC = iAC(NULL,0,i); double acP = iAC(NULL,0,i+1); int acD = 0; if (acC>acP) acD=1; if (acC<acP) acD=2;
      double aoC = iAO(NULL,0,i); double aoP = iAO(NULL,0,i+1); int aoD = 0; if (aoC>aoP) aoD=1; if (aoC<aoP) aoD=2;
      Buffer1[i] = 0.0;
      Buffer2[i] = 0.0;
      Buffer3[i] = 0.0;
      Buffer4[i] = 0.0;
      Buffer5[i] = 0.0;
      Buffer6[i] = 0.0;
      Buffer7[i] = 0.0;
      Buffer8[i] = 0.0;
    
      trend[i] = (acD==1 && aoD==1) ? 1 : (acD==2 && aoD==2) ? 2 : (acD==1 && aoD==2)? 3 : 4;
     

      if(trend[i] == 1) { if(haOpen>haClose) { Buffer1[i] = haOpen;  Buffer2[i] = haClose; }
                          if(haOpen<haClose) { Buffer1[i] = haClose; Buffer2[i] = haOpen;  }
                                                                     Buffer5[i] = haHigh;
                                                                     Buffer6[i] = haLow;   } 
      if(trend[i] == 2) { if(haOpen>haClose) { Buffer1[i] = haClose; Buffer2[i] = haOpen;  }
                          if(haOpen<haClose) { Buffer1[i] = haOpen;  Buffer2[i] = haClose; }
                                                                     Buffer5[i] = haLow;
                                                                     Buffer6[i] = haHigh;  } 
      if(trend[i] == 3) { if(haOpen>haClose) { Buffer3[i] = haOpen;  Buffer4[i] = haClose; }
                          if(haOpen<haClose) { Buffer3[i] = haClose; Buffer4[i] = haOpen;  }
                                                                     Buffer7[i] = haHigh;
                                                                     Buffer8[i] = haLow;   } 
      if(trend[i] == 4) { if(haOpen>haClose) { Buffer3[i] = haClose; Buffer4[i] = haOpen;  }
                          if(haOpen<haClose) { Buffer3[i] = haOpen;  Buffer4[i] = haClose; }
                                                                     Buffer7[i] = haLow;
                                                                     Buffer8[i] = haHigh;  }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (trend[whichBar] != trend[whichBar+1])
            switch((int)trend[whichBar])
            {
               case 1 :  doAlert("up");      break;
               case 2 :  doAlert("down");    break;
               case 3 :  doAlert("neutral"); break;
               case 4 :  doAlert("neutral"); break;
            }               
   }    
return(rates_total);
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," heiken ashi zone trade ",doWhat);
             if (alertsMessage)    Alert(message);
             if (alertsPushNotif)  SendNotification(message);
             if (alertsEmail)      SendMail(_Symbol+" heiken ashi zone trade ",message);
             if (alertsSound)      PlaySound("alert2.wav");
      }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}